import aima.core.search.framework.Problem;
import aima.core.search.framework.Search;
import aima.core.search.framework.TreeSearch;
import aima.core.search.framework.GraphSearch;
import aima.core.search.informed.AStarSearch;
import aima.core.search.framework.SearchAgent;

import java.util.List;
import java.util.Iterator;
import aima.core.agent.Action;

public class FlashlightAStarTest {

	public static void doAtest(int size, int[] speeds) {
		try {
			System.out.println("Flashlight test");
			
			FlashLightState state = new FlashLightState(size, speeds);

			Problem problem = new Problem(
				state, 
				FlashLightFunctionFactory.getActionsFunction(), 
				FlashLightFunctionFactory.getResultFunction(), 
				new FlashLightGoalTest(), 
				new FlashLightStepCostFunction(state)
				);
			Search search = new AStarSearch(
				new GraphSearch(),
				new FlashLightHeuristicFunction()
				);
			SearchAgent agent = new SearchAgent(problem, search);

			/* Change this ***************************
			System.out.println( agent.getActions().toString()) ;
			System.out.println(agent.getInstrumentation().getProperty("nodesExpanded") + " nodes Expanded");
			System.out.println(agent.getInstrumentation().getProperty("queueSize") + " queue size");
			System.out.println(agent.getInstrumentation().getProperty("maxQueueSize") + " max queue size");
			********************** */

		} catch (Exception e) {
			e.printStackTrace();
		}
	}
	
	public static void main(String[] args) {
		// change this to get size and speeds from args ***********************
		int size = 4;
		int[] speeds = new int[]{1, 2, 5, 10};

		doAtest(size, speeds);
	}
}
